﻿-- Author	:	Knoot
RaidRollHelper = LibStub("AceAddon-3.0"):NewAddon("RaidRollHelper")
local Console = LibStub("AceConsole-3.0")
LibStub("AceEvent-3.0"):Embed(RaidRollHelper)
local AceGUI = LibStub("AceGUI-3.0")
RRH_TICKER = C_Timer.NewTicker(1, function() RL:rollTimer() end)
RRH_TICKER:Cancel()
RRH_ROLL_LIST={}
--		SETTINGS
																					local testMODE=false
RRH_VER=1.6
RRH_SUB_VER=1.0
RRH_FORCE_HIDE_FRAME=false
local start_hide=true
local timeToRoll=60
--		/SETTINGS
local RL=RRH_FUNCTIONS
ITEM_CLASS_NEED={
	["Тканевые"]={
		['PRIEST']=true,
		['MAGE']=true,
		['WARLOCK']=true,
	},
	["Кожаные"]={
		['ROGUE']=true,
		['MONK']=true,
		['DRUID']=true,
		['DEMONHUNTER']=true,
	},
	["Кольчужные"]={
		['HUNTER']=true,
		['SHAMAN']=true,
	},
	["Латные"]={
		['WARRIOR']=true,
		['PALADIN']=true,
		['DEATHKNIGHT']=true,
	},
	['Разное']={
		['WARRIOR']=true,
		['PALADIN']=true,
		['DEATHKNIGHT']=true,
		['HUNTER']=true,
		['SHAMAN']=true,
		['ROGUE']=true,
		['MONK']=true,
		['DRUID']=true,
		['DEMONHUNTER']=true,
		['PRIEST']=true,
		['MAGE']=true,
		['WARLOCK']=true,
	},
	["Artifact Relic"]={			--Реликвии
		['Arcane']={				--тайная магия
			['DEMONHUNTER']=true,
			['DRUID']=true,
			['HUNTER']=true,
			['MAGE']=true,
			['PALADIN']=true,
		},
		['Blood']={				--кровь
			['DEATHKNIGHT']=true,
			['DRUID']=true,
			['HUNTER']=true,
			['PRIEST']=true,
			['ROGUE']=true,
			['WARLOCK']=true,
			['WARRIOR']=true,
		},
		['Fel']={				--
			['DEMONHUNTER']=true,
			['ROGUE']=true,
			['WARLOCK']=true,
		},
		['Fire']={				--огонь
			['DEATHKNIGHT']=true,
			['DRUID']=true,
			['MAGE']=true,
			['PALADIN']=true,
			['SHAMAN']=true,
			['WARLOCK']=true,
			['WARRIOR']=true,
		},
		['Frost']={				--лед
			['DEATHKNIGHT']=true,
			['DRUID']=true,
			['MAGE']=true,
			['MONK']=true,
			['SHAMAN']=true,
		},
		['Holy']={				--свет
			['PALADIN']=true,
			['PRIEST']=true,
		},
		['Iron']={				--железо
			['DEATHKNIGHT']=true,
			['DEMONHUNTER']=true,
			['HUNTER']=true,
			['MONK']=true,
			['ROGUE']=true,
			['SHAMAN']=true,
			['WARRIOR']=true,
		},
		['Life']={				--жизнь
			['DRUID']=true,
			['HUNTER']=true,
			['MONK']=true,
			['PALADIN']=true,
			['PRIEST']=true,
			['SHAMAN']=true,
		},
		['Shadow']={				--тьма
			['DEATHKNIGHT']=true,
			['DEMONHUNTER']=true,
			['PRIEST']=true,
			['ROGUE']=true,
			['WARLOCK']=true,
			['WARRIOR']=true,
		},
		['Storm']={				--
			['HUNTER']=true,
			['MONK']=true,
			['ROGUE']=true,
			['SHAMAN']=true,
			['WARRIOR']=true,
		},
	},
	['set']={						--сетовые шмотки
		[152112]='DEATHKNIGHT',			-- грудь
		[152113]='DEATHKNIGHT',	-- спина
		[152114]='DEATHKNIGHT',	-- перчатки
		[152115]='DEATHKNIGHT',	-- голова
		[152116]='DEATHKNIGHT',	-- ноги
		[152117]='DEATHKNIGHT',	-- плечо
		[152118]='DEMONHUNTER',			-- грудь
		[152119]='DEMONHUNTER',	-- спина
		[152120]='DEMONHUNTER',	-- перчатки
		[152121]='DEMONHUNTER',	-- голова
		[152122]='DEMONHUNTER',	-- ноги
		[152123]='DEMONHUNTER',	-- плечо
		[152124]='DRUID',				-- грудь
		[152125]='DRUID',		-- спина
		[152126]='DRUID',		-- перчатки
		[152127]='DRUID',		-- голова
		[152128]='DRUID',		-- ноги
		[152129]='DRUID',		-- плечо
		[152130]='HUNTER',				-- грудь
		[152131]='HUNTER',		-- спина
		[152132]='HUNTER',		-- перчатки
		[152133]='HUNTER',		-- голова
		[152134]='HUNTER',		-- ноги
		[152135]='HUNTER',		-- плечо
		[152140]='MAGE',				-- грудь
		[152136]='MAGE',		-- спина
		[152137]='MAGE',		-- перчатки
		[152138]='MAGE',		-- голова
		[152139]='MAGE',		-- ноги
		[152141]='MAGE',		-- плечо
		[152142]='MONK',				-- грудь
		[152143]='MONK',		-- спина
		[152144]='MONK',		-- перчатки
		[152145]='MONK',		-- голова
		[152146]='MONK',		-- ноги
		[152147]='MONK',		-- плечо
		[152148]='PALADIN',				-- грудь
		[152149]='PALADIN',		-- спина
		[152150]='PALADIN',		-- перчатки
		[152151]='PALADIN',		-- голова
		[152152]='PALADIN',		-- ноги
		[152153]='PALADIN',		-- плечо
		[152158]='PRIEST',				-- грудь
		[152154]='PRIEST',		-- спина
		[152155]='PRIEST',		-- перчатки
		[152156]='PRIEST',		-- голова
		[152157]='PRIEST',		-- ноги
		[152159]='PRIEST',		-- плечо
		[152160]='ROGUE',				-- грудь
		[152161]='ROGUE',		-- спина
		[152162]='ROGUE',		-- перчатки
		[152163]='ROGUE',		-- голова
		[152164]='ROGUE',		-- ноги
		[152165]='ROGUE',		-- плечо
		[152166]='SHAMAN',				-- грудь
		[152167]='SHAMAN',		-- спина
		[152168]='SHAMAN',		-- перчатки
		[152169]='SHAMAN',		-- голова
		[152170]='SHAMAN',		-- ноги
		[152171]='SHAMAN',		-- плечо
		[152176]='WARLOCK',				-- грудь
		[152172]='WARLOCK',		-- спина
		[152173]='WARLOCK',		-- перчатки
		[152174]='WARLOCK',		-- голова
		[152175]='WARLOCK',		-- ноги
		[152177]='WARLOCK',		-- плечо
		[152178]='WARRIOR',				-- грудь
		[152179]='WARRIOR',		-- спина
		[152180]='WARRIOR',		-- перчатки
		[152181]='WARRIOR',		-- голова
		[152182]='WARRIOR',		-- ноги
		[152183]='WARRIOR'		-- плечо
	},
}


if testMODE then
-- "PARTY", "RAID", "GUILD"
	RRH_MSG_LOCATION="GUILD"
	RRH_PREFIX='RRHelp_v'..RRH_VER+0.1
else
	RRH_MSG_LOCATION="RAID"
	RRH_PREFIX='RRHelp_v'..RRH_VER
end

RRH_PREFIX_NEW	='new_'
RRH_PREFIX_GETROLL='get_'
RRH_PREFIX_SETROLL='set_'
RRH_PREFIX_ROLL	='roll_'
RRH_PREFIX_VER	='ver_'
RRH_VER_TIMER=GetTime()
local classDisplayName, class, classID= UnitClass("player");RRH_PLAYER_CLASS=class
RRH_PLAYER_NAME=GetUnitName('player', false)
function RaidRollHelper:OnEnable()
	RegisterAddonMessagePrefix(RRH_PREFIX)
	local rollWidth,rollHeight=100,275
	local groupWidth,groupHeight=rollWidth,rollHeight-25
	
--	current version find
	if not testMODE then
		local cur_ver=CreateFrame("Frame",'current_version_find',UIParent)
			cur_ver:RegisterEvent('PLAYER_ENTERING_WORLD')
			cur_ver:SetScript('OnEvent',function(event) SendAddonMessage(RRH_PREFIX, RRH_PREFIX_VER..RRH_VER,'GUILD')	end)
	end
	
	RRH_FRAME=CreateFrame("Frame",'RaidRollHelperFrame',UIParent)
	RL:SetFrame(RRH_FRAME,rollWidth,rollHeight,true,true)
		RRH_FRAME:SetScript("OnMouseDown", function(frame) frame:StartMoving() end)
		RRH_FRAME:SetScript("OnMouseUp", function(frame)
			frame:StopMovingOrSizing()
			local point, relativeTo,relativePoint, xOfs, yOfs = RRH_FRAME:GetPoint(1)
			RaidRollHelper.db.global.point=point
			RaidRollHelper.db.global.relativeTo=relativeTo
			RaidRollHelper.db.global.relativePoint=relativePoint
			RaidRollHelper.db.global.xOfs=xOfs
			RaidRollHelper.db.global.yOfs=yOfs
		end)
		if RaidRollHelper.db.global.point then
			RRH_FRAME:ClearAllPoints()
			RRH_FRAME:SetPoint(
				RaidRollHelper.db.global.point,
				RaidRollHelper.db.global.relativeTo,
				RaidRollHelper.db.global.relativePoint,
				RaidRollHelper.db.global.xOfs,
				RaidRollHelper.db.global.yOfs
			)
		end

	RRH_GROUP=CreateFrame("Frame",'RaidRollHelper_group',RRH_FRAME)
		RL:SetFrame(RRH_GROUP,groupWidth,groupHeight)
		RRH_GROUP:SetPoint("TOPLEFT",0,0)
	
	RRH_ICO=CreateFrame("Frame",'RaidRollHelper_ICO',RRH_GROUP)
		RRH_ICO:SetPoint("TOPLEFT",RRH_GROUP,"TOPLEFT",0,0)
		RRH_ICO:SetWidth(groupWidth)
		RRH_ICO:SetHeight(groupWidth)
		RRH_ICO.tex=RRH_ICO:CreateTexture()
		RL:SetICO()
		
	RRH_ILVLS=CreateFrame("SimpleHTML",'RaidRollHelper_ilvls',RRH_GROUP)
		RRH_ILVLS:SetText('<html><body><h1>Heading1</h1><p>A paragraph</p></body></html>');
		RRH_ILVLS:SetFont('Fonts\\FRIZQT__.TTF', 11);
		RRH_ILVLS:SetWidth(groupWidth)
		RRH_ILVLS:SetHeight(100)
		RRH_ILVLS:SetPoint("TOPLEFT",RRH_ICO, "BOTTOMLEFT", 0, 0)
		
	RRH_NEEDBTN=CreateFrame("Button", 'RaidRollHelper_needButton',RRH_GROUP)
		RL:SetButton(RRH_NEEDBTN, 'Нужно', RRH_ILVLS,"BOTTOMLEFT")
		
	RRH_FALSEBTN=CreateFrame("Button", 'RaidRollHelper_falseButton',RRH_GROUP)
		RL:SetButton(RRH_FALSEBTN, 'Отказаться',RRH_NEEDBTN,"BOTTOMLEFT")
	
	closeRaidRollHelper=CreateFrame("Button", 'RaidRollHelper_closeRaidRollHelper	',RRH_FRAME)
		closeRaidRollHelper:SetPoint("BOTTOM",RRH_FRAME,"BOTTOM",0,0)
		RL:SetButton(closeRaidRollHelper, 'Закрыть')
		closeRaidRollHelper:SetWidth(rollWidth)
		closeRaidRollHelper:SetScript('OnClick', function() RRH_FRAME:Hide();RRH_FORCE_HIDE_FRAME=true end)
		
	
	local MSGincoming = CreateFrame("Frame")
		MSGincoming:RegisterEvent("CHAT_MSG_ADDON")
		MSGincoming:SetScript("OnEvent", function(self, event, ...)
			local prefix,item,_,sender=...
			local senderFULL=sender
			sender=RL:split(sender,'-')[1]
		--	addon && addon_ver FILTER
			if prefix~=RRH_PREFIX then return end
			
			prefix=RL:clearPrefix(item)			-- prefix new_/get_/...
			item=RL:clearPrefix(item,prefix)	-- MSG without prefix
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, iconFileDataID, itemSellPrice, itemClassID, itemSubClassID,bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo(item)
			local itemID=tonumber(string.match(item,'item:([0-9]+):'))
			if prefix==RRH_PREFIX_NEW then
				RRH_FORCE_HIDE_FRAME=false
				local hide=false
				local isRelic=false
			--	relic FILTER
				if itemSubType=='Реликвия артефакта' then
					local _,_,relicType,_=C_ArtifactUI.GetRelicInfoByItemID(string.match(item,'item:(%d+)'))
					if not ITEM_CLASS_NEED["Artifact Relic"][relicType][RRH_PLAYER_CLASS] then hide=true end
			--	itemTYPE FILTER cloak/other types
				elseif not ((itemSubType=='Тканевые' and itemEquipLoc=='INVTYPE_CLOAK') or itemSubType=='Разное') then
					if ITEM_CLASS_NEED[itemSubType] and not ITEM_CLASS_NEED[itemSubType][RRH_PLAYER_CLASS] then hide=true end
				end
			--	sender FILTER
				if not testMODE then
					if sender==RRH_PLAYER_NAME then hide=true end
				end
				local exist=false
				for i=1,#RRH_ROLL_LIST do
					if RRH_ROLL_LIST[i][itemName]~=nil then exist=i;break; end
				end
			--	itemSet FILTER
				if ITEM_CLASS_NEED.set[itemID] and ITEM_CLASS_NEED.set[itemID]~=RRH_PLAYER_CLASS then hide=true end
				
				if exist then
				--	if double roll
					for i=1,#RRH_ROLL_LIST[exist][itemName].ilvls do
						if RRH_ROLL_LIST[exist][itemName].ilvls[i].sender==sender then return end
					end
					
					RRH_ROLL_LIST[exist][itemName]['ilvls'][#RRH_ROLL_LIST[exist][itemName]['ilvls']+1]={
						['sender']=sender,['ilvl']=itemLevel,['Item_link']=item
					}
					RRH_ROLL_LIST[exist][itemName]['end_time']=GetTime()+timeToRoll
				else
					RRH_ROLL_LIST[#RRH_ROLL_LIST+1]={}
					RRH_ROLL_LIST[#RRH_ROLL_LIST][itemName]={}
					RRH_ROLL_LIST[#RRH_ROLL_LIST][itemName]['link']=item
					RRH_ROLL_LIST[#RRH_ROLL_LIST][itemName]['ico']=iconFileDataID
					RRH_ROLL_LIST[#RRH_ROLL_LIST][itemName]['roll']={
					--[[
						[1]={['name']='n1',['roll']=RL:GetRoll()},
						[2]={['name']='n2',['roll']=RL:GetRoll()},
						[3]={['name']='n3',['roll']=RL:GetRoll()},
						[4]={['name']='n4',['roll']=RL:GetRoll()}
					]]
					}
					RRH_ROLL_LIST[#RRH_ROLL_LIST][itemName]['ilvls']={
					--[[
						[1]={['sender']='n1',['ilvl']=935,['Item_link']=GetContainerItemLink(0,2)},
						[2]={['sender']='n2',['ilvl']=920,['Item_link']=GetContainerItemLink(0,3)},
						[3]={['sender']='n3',['ilvl']=955,['Item_link']=GetContainerItemLink(0,4)}
					]]
					}
					RRH_ROLL_LIST[#RRH_ROLL_LIST][itemName]['ilvls'][#RRH_ROLL_LIST[#RRH_ROLL_LIST][itemName]['ilvls']+1]={
						['sender']=sender,['ilvl']=itemLevel,['Item_link']=item
					}
					RRH_ROLL_LIST[#RRH_ROLL_LIST][itemName]['end_time']=GetTime()+timeToRoll
					RRH_ROLL_LIST[#RRH_ROLL_LIST][itemName]['hide']=hide
				end
				
				RL:startTimer()
			elseif prefix==RRH_PREFIX_SETROLL then
				local i=0
				local sender,itemName,ROLL=RL:split(item,'#')[1],RL:split(item,'#')[2],tonumber(RL:split(item,'#')[3])
				--	GET i
				for n=1,#RRH_ROLL_LIST do
					if RRH_ROLL_LIST[n][itemName] then i=n;break end
				end
				if i==0 then return end
				
			--	if double roll
				local exist=false
				for n=1,#RRH_ROLL_LIST[i][itemName].roll do
					if RRH_ROLL_LIST[i][itemName].roll[n].name==sender then exist=true;break; end
				end
				
				if not exist then
					RRH_ROLL_LIST[i][itemName].roll[#RRH_ROLL_LIST[i][itemName].roll+1]={['name']=sender,['roll']=ROLL}
					RRH_ROLL_LIST[i][itemName].roll=RL:sortRoll(RRH_ROLL_LIST[i][itemName].roll)
				end
			elseif prefix==RRH_PREFIX_GETROLL then
				RL:serverINITroll(item,sender)
			elseif prefix==RRH_PREFIX_VER and sender~=RRH_PLAYER_NAME then
				if RRH_VER>tonumber(item) then
					SendAddonMessage(RRH_PREFIX, RRH_PREFIX_VER..RRH_VER, 'WHISPER', senderFULL)
				elseif RRH_VER<tonumber(item) then
					print('|cFFFF99FFВаша версия RaidRollHelper устарела.|r')
					RL:newVerSound()
				end
			end
		end)
	Console:RegisterChatCommand('ro', 'RaidRollHelperStart')
	
	if start_hide then
		RRH_FRAME:Hide()
	end
end


function Console:RaidRollHelperStart(str)
	if str=='' then Console:RaidRollHelperHelp();return end
	if str=='reset' then
		RaidRollHelper.db.global.point=nil
		RaidRollHelper.db.global.relativeTo=nil
		RaidRollHelper.db.global.relativePoint=nil
		RaidRollHelper.db.global.xOfs=nil
		RaidRollHelper.db.global.yOfs=nil
		RRH_FRAME:ClearAllPoints()
		RRH_FRAME:SetPoint("CENTER",UIParent,"CENTER",0,0)
		print('Позиция по умолчанию')
		return
	end
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, iconFileDataID, itemSellPrice, itemClassID, itemSubClassID,bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo(str)
	
--	if not relic or armor
	if not (itemType=='Самоцвет' and itemSubType=='Реликвия артефакта') and not itemType=='Доспехи' then print('Предмет не является доспехом или реликвией артефакта');return end
--	if item not exist in bags	
	if not RL:ifItemExist(itemLink) then print('Предмет не найден в сумках');return end
	
	SendAddonMessage(RRH_PREFIX, RRH_PREFIX_NEW..itemLink, RRH_MSG_LOCATION)
end

function RaidRollHelper:OnLoad()
	
end

function RaidRollHelper:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("RaidRollHelperDB")
end

function RaidRollHelper:OnDisable()
	
end

function Console:RaidRollHelperHelp() -- Подсказки в игре
	print("|cFFFFFFFFRaidRollHelper v_"..RRH_VER..'('..RRH_SUB_VER..")|r |cFFFF99FF(=^..^=)|r:")
	print("/|cFFFF99FFro|r reset - вернуть окно рола в середину экрана")
	print("/|cFFFF99FFro|r itemLink\n"..
			--"|cFFFF99FFitemLink|r - ссылка на предмет. Предмет должен находиться в сумке и являться частью экипировки(шея/перчатки/реликвия артефакта и т.д.).\n"..
			"Чтобы получить |cFFFF99FFitemLink|r, кликните мышью на предмет при нажатой клавише |cFFFF99FFShift|r.\n"..
			"|cFFFF99FFitemLink|r - |cffa335ee|Hitem:151311::::::::110:270::2:3:1726:1517:3528:::|h[Печать Триумвирата]|h|r")
end