﻿RRH_FUNCTIONS={}
RRH_FRAME={}
RRH_GROUP={}
RRH_ICO={}
RRH_ILVLS={}
RRH_NEEDBTN={}
RRH_FALSEBTN={}

local RL=RRH_FUNCTIONS

function RL:newVerSound()
	if GetTime()>RRH_VER_TIMER+60000 then
		PlaySound(8959, "Master")
		RRH_VER_TIMER=GetTime()
	end
end

function RL:clearPrefix(str,prefix)
	if prefix==nil then
		local prefix='^%w+_'
		if string.find(str,prefix) then
			str=string.match(str,prefix)
			return str
		else
			return false
		end
	else
		local _prefix='^'..prefix
		if string.find(str,_prefix) then
			str=string.gsub(str,_prefix,'')
			return str
		else
			return false
		end
	end
	
end

function RL:serverINITroll(item,sender)
	for i=1,#RRH_ROLL_LIST do
		if RRH_ROLL_LIST[i][item] then
			if RRH_ROLL_LIST[i][item].ilvls[1]['sender']==RRH_PLAYER_NAME then
				SendAddonMessage(RRH_PREFIX, RRH_PREFIX_SETROLL..sender..'#'..item..'#'..RL:GetRoll(), RRH_MSG_LOCATION)
			else
				return
			end
		end
	end
end

function RL:startTimer()
	RRH_TICKER:Cancel()
	RRH_TICKER = C_Timer.NewTicker(1, function() RL:rollTimer() end)
end

function RL:ifItemExist(itemLink)
	for bag=0, NUM_BAG_SLOTS do
		for slot = 1, GetContainerNumSlots(bag) do
			if GetContainerItemLink(bag,slot)==itemLink then return true end
		end
	end
	return false
end

function RL:deleteRoll(i)
	for i=i+1,#RRH_ROLL_LIST do
		RRH_ROLL_LIST[i-1]=RRH_ROLL_LIST[i]
	end
	RRH_ROLL_LIST[#RRH_ROLL_LIST]=nil
end

function RL:sendWinner(itemName)
	local i=0
	for n=1,#RRH_ROLL_LIST do
		if RRH_ROLL_LIST[n][itemName] then i=n;break end
	end
	if i==0 then return end
	
	local item=RRH_ROLL_LIST[i][itemName]
	for n=1,#item.ilvls do
		if item.roll[n] and item.ilvls[n].sender==RRH_PLAYER_NAME then
			local MSG=item.ilvls[n].Item_link..' победитель '..item.roll[n].name
			print(MSG)
			SendChatMessage(MSG, RRH_MSG_LOCATION)
		end
	end
	
--	прогон ролов
--[[
	for j=1,#RRH_ROLL_LIST[i][itemName].roll do
		print(RRH_ROLL_LIST[i][itemName].roll[j].name..' | '..RRH_ROLL_LIST[i][itemName].roll[j].roll)
	end
]]
end

function RL:rollTimer()
	local cancel_timer=false
	for i=1,#RRH_ROLL_LIST do
	if cancel_timer then break end
		for k,v in pairs(RRH_ROLL_LIST[i]) do
			local arr=RRH_ROLL_LIST[i][k].ilvls
			local end_of_timer=RRH_ROLL_LIST[i][k].end_time
			for ii=1,#arr do
				if arr[ii].sender==RRH_PLAYER_NAME and end_of_timer<GetTime() then cancel_timer=true; item=k; break; end
			end
		end
	end
	if cancel_timer then
		RL:sendWinner(item)
	end
	RL:upd_roll()
	if #RRH_ROLL_LIST==0 then RRH_TICKER:Cancel();RL:upd_roll() end
end

function RL:linkReplace(link)
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, iconFileDataID, itemSellPrice, itemClassID, itemSubClassID,bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo(link)
	link=string.gsub(link,'\124','|')
	link=string.gsub(link,itemName,itemLevel)
	link=string.gsub(link,'|','\124')
	return link
end

function RL:GetRoll()
	return math.random(1,100)
end

function RL:SetLabel(label, text, relative, relPoint, Width)
	if Width==nil then Width=100 end
	if text==nil then text='' end
	
	local fs=label:CreateFontString('testfont', "OVERLAY", "GameFontNormal")
	fs:SetPoint("TOPLEFT",relative, relPoint, 0, 0)
	fs:SetWidth(100)
	fs:SetHeight(fs:GetStringHeight())
    fs:SetText(text)
		
	label:SetPoint("TOPLEFT",relative, relPoint, 0, 0)
	label:SetWidth(100)
	label:SetHeight(fs:GetStringHeight())
end

function RL:SetTexture(obj,texture)
	local tex = obj:CreateTexture()
		tex:SetTexture(texture)
		tex:SetAllPoints()
end

function RL:SetButton(button, text, relative, relPoint, Width, Height)
	if Width==nil then Width=100 end
	if Height==nil then Height=24 end
	if text==nil then text='' end
	
	button:SetText(text)
	button:SetNormalFontObject("GameFontNormal")
	if relative and relPoint then
		button:SetPoint("TOPLEFT",relative,relPoint,0,0)
	end
	button:SetWidth(Width)
	button:SetHeight(Height)
	
	local ntex = button:CreateTexture()
	ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex:SetAllPoints()	
	button:SetNormalTexture(ntex)
	
	local htex = button:CreateTexture()
	htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex:SetTexCoord(0, 0.625, 0, 0.6875)
	htex:SetAllPoints()
	button:SetHighlightTexture(htex)
	
	local ptex = button:CreateTexture()
	ptex:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex:SetAllPoints()
	button:SetPushedTexture(ptex)
end

function RL:SetICO(texture)
	if texture==nil then texture=134414 end
	RRH_ICO.tex:SetTexture(texture)
	RRH_ICO.tex:SetAllPoints()
end

function RL:SetFrame(frame, Width, Height, EnableMouse, SetMovable)
	local function MoverSizer_OnMouseUp(mover)
		local frame = mover:GetParent()
		frame:StopMovingOrSizing()
		local self = frame.obj
		local status = self.status or self.localstatus
		status.width = frame:GetWidth()
		status.height = frame:GetHeight()
		status.top = frame:GetTop()
		status.left = frame:GetLeft()
	end
	local function Title_OnMouseDown(frame)
		frame:GetParent():StartMoving()
		AceGUI:ClearFocus()
	end
	
	if EnableMouse==nil then EnableMouse=false end
	if SetMovable==nil then SetMovable=false end
	if Width==nil then Width=100 end
	if Height==nil then Height=100 end
	
	local tex = frame:CreateTexture(nil, "BACKGROUND")
	tex:SetAllPoints()
	tex:SetColorTexture(0, 0, 0, 0.5)
	
	frame:SetBackdropColor(0, 0, 0, 1)
	frame:EnableMouse(EnableMouse)
	frame:SetMovable(SetMovable)
	frame:SetWidth(Width)
	frame:SetHeight(Height)
	frame:SetPoint("CENTER",UIParent,0,0)
end

function RL:dump(o)
	if type(o) == 'table' then
		local s = '{ \n'
		for k,v in pairs(o) do
		if k~=nil then
			if v==nil then v='nil' end
			if type(k) ~= 'number' then k = '"'..k..'"' end
				s = s .. '['..k..'] = ' .. RL:dump(v) .. ',\n'
			end
		end
			return s .. '} \n'
		else
			return tostring(o)
	end
end

function RL:split(inputstr, sep)
	if sep == nil then sep = "%s" end
	local t={} ; i=1
	for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
		t[i] = str
		i = i + 1
	end
	return t
end

function RL:makeHash(leng)
	if leng==nil then leng=10 end
		local text = "";
		local possible = "abcdefghijklmnopqrstuvwxyzQWERTYUIOPASDFGHJKLZXCVBNM1234567890";
		for i=0,leng do
		local charAt=math.floor(math.random()*string.len(possible))
		text=text..possible:sub(charAt,charAt)
	end
		return text;
end

function RL:spairs(t, order)
		-- collect the keys
		local keys = {}
		for k in pairs(t) do keys[#keys+1] = k end

		-- if order function given, sort by it by passing the table and keys a, b,
		-- otherwise just sort the keys 
		if order then
				table.sort(keys, function(a,b) return order(t, a, b) end)
		else
				table.sort(keys)
		end

		-- return the iterator function
		local i = 0
		return function()
				i = i + 1
				if keys[i] then
						return keys[i], t[keys[i]]
				end
		end
end

function RL:comma_value(amount)
	local formatted = amount
	while true do	
		formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
		if (k==0) then
			break
		end
	end
	return formatted
end

function RL:round(val, decimal)
	if (decimal) then
		return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
	else
		return math.floor(val+0.5)
	end
end

function RL:format_num(amount, decimal, prefix, neg_prefix)
	local str_amount,	formatted, famount, remain

	decimal = decimal or 2	-- default 2 decimal places
	neg_prefix = neg_prefix or "-" -- default negative sign

	famount = math.abs(round(amount,decimal))
	famount = math.floor(famount)

	remain = round(math.abs(amount) - famount, decimal)

				-- comma to separate the thousands
	formatted = comma_value(famount)

				-- attach the decimal portion
	if (decimal > 0) then
		remain = string.sub(tostring(remain),3)
		formatted = formatted .. "," .. remain ..
								string.rep("0", decimal - string.len(remain))
	end

				-- attach prefix string e.g '$' 
	formatted = (prefix or "") .. formatted 

				-- if value is negative then format accordingly
	if (amount<0) then
		if (neg_prefix=="()") then
			formatted = "("..formatted ..")"
		else
			formatted = neg_prefix .. formatted 
		end
	end

	return formatted
end

function RL:sortRoll(a)
	local arr=a
	for _=1,#arr do
		local last=10000
		for i=1,#arr do
			local _temp
			if arr[i].roll>last then
				_temp=arr[i-1]
				arr[i-1]=arr[i]
				arr[i]=_temp
			end
			last=arr[i].roll
		end
	end
return arr
end

function RL:sortilvls(a)
	local arr=a
	for _=1,#arr do
		local last=10000
		for i=1,#arr do
			local _temp
			if arr[i].ilvl>last then
				_temp=arr[i-1]
				arr[i-1]=arr[i]
				arr[i]=_temp
			end
			last=arr[i].ilvl
		end
	end
return arr
end

function RL:upd_roll()
	--RRH_FRAME, RRH_GROUP, RRH_ICO, RRH_ILVLS, RRH_NEEDBTN, RRH_FALSEBTN
	if #RRH_ROLL_LIST==0 then
		RRH_NEEDBTN:SetScript('OnClick', function() end)
		RRH_FALSEBTN:SetScript('OnClick', function() end)
		RRH_FRAME:Hide()
	end
	local isDel=false
	for i=1,#RRH_ROLL_LIST do
		local isShow=false
		if isDel then RL:upd_roll();break end
		for k,v in pairs(RRH_ROLL_LIST[i]) do
			--local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, iconFileDataID, itemSellPrice, itemClassID, itemSubClassID,bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo(RRH_ROLL_LIST[i][k].Item_link)
			if RRH_ROLL_LIST[i][k].end_time<GetTime()  then
				RL:deleteRoll(i);isDel=true
			else
				if RRH_ROLL_LIST[i][k].hide then break end
				if not RRH_FORCE_HIDE_FRAME then RRH_FRAME:Show() end
				local fsHeight=13
				
				RL:SetICO(RRH_ROLL_LIST[i][k].ico)
				--[[RRH_ICO:SetScript("OnEnter", function() GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");GameTooltip:SetHyperlink(RRH_ROLL_LIST[i][k].link); end )
				RRH_ICO:SetScript("OnLeave", function() GameTooltip:FadeOut() end)]]
				
				
				local ilvls=''
				local senders=''
				RRH_ROLL_LIST[i][k].ilvls=RL:sortilvls(RRH_ROLL_LIST[i][k].ilvls)
				for ii=1,#RRH_ROLL_LIST[i][k].ilvls do
					local ilvl=RRH_ROLL_LIST[i][k].ilvls[ii].ilvl
					local link=RRH_ROLL_LIST[i][k].ilvls[ii].Item_link
					local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, iconFileDataID, itemSellPrice, itemClassID, itemSubClassID,bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo(RRH_ROLL_LIST[i][k].ilvls[ii].Item_link)
					--ilvls=ilvls..RRH_ROLL_LIST[i][k].ilvls[ii].ilvl..'\n'
					ilvls=ilvls..'<h1 align="center">'..RL:linkReplace(link)..'</h1>'..'\n'
					senders=senders..RRH_ROLL_LIST[i][k].ilvls[ii].sender..'#'
				end
				RRH_ILVLS:SetText('<html><body>'..ilvls..'</body></html>')
				RRH_ILVLS:SetScript('OnHyperlinkEnter',function(self,link)
					GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
					GameTooltip:SetHyperlink(link)
				end)
				
				RRH_ICO:SetScript('OnEnter',function() GameTooltip:FadeOut() end)
				RRH_ILVLS:SetScript('OnLeave',function() GameTooltip:FadeOut() end)
				RRH_ILVLS:SetScript('OnHyperlinkLeave',function() GameTooltip:FadeOut() end)
				RRH_ILVLS:SetScript('OnEnter',function() GameTooltip:FadeOut() end)
				
				
				RRH_NEEDBTN:SetScript('OnClick', function()
					RRH_ROLL_LIST[i][k].hide=true
					SendAddonMessage(RRH_PREFIX, RRH_PREFIX_GETROLL..k, RRH_MSG_LOCATION)
					RL:upd_roll()
				end)
				RRH_FALSEBTN:SetScript('OnClick', function()
					RRH_ROLL_LIST[i][k].hide=true
					RL:upd_roll() 
				end)
				isShow=true
			end
		end
		if isShow then
			break
		else
			RRH_NEEDBTN:SetScript('OnClick', function() end)
			RRH_FALSEBTN:SetScript('OnClick', function() end)
			RRH_FRAME:Hide()
		end
		
	end
end